"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _basic = _interopRequireDefault(require("./basic"));

var _saferEval = _interopRequireDefault(require("safer-eval"));

var _lodash = require("lodash");

var ArrayModel =
/*#__PURE__*/
function (_BasicModel) {
  (0, _inherits2.default)(ArrayModel, _BasicModel);

  // https://github.com/babel/babel/issues/8417

  /*:: attributes: Object; */

  /*:: keyName: string = ''; */
  function ArrayModel(attrs, children) {
    var _this;

    (0, _classCallCheck2.default)(this, ArrayModel);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ArrayModel).call(this, 'array', attrs));
    var builder = _this.attributes.builder;

    if (typeof builder === 'string') {
      builder = (0, _saferEval.default)(builder);
    }

    if (typeof builder === 'function') {
      // $FlowFixMe
      _this.toJson = function () {
        return builder({
          attributes: (0, _objectSpread2.default)({}, attrs, {
            builder: undefined
          }),
          children: children
        });
      };

      return (0, _possibleConstructorReturn2.default)(_this, (0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    }

    if (children && children.length) {
      var flattenChilden = (0, _lodash.flatten)(children);
      var toolbar = flattenChilden.find(function (item) {
        return item.__TOOLBAR__;
      });

      if (toolbar) {
        _this.attributes.toolbar = toolbar;
      }

      var otherChildren = flattenChilden.filter(function (item) {
        return !item.__TOOLBAR__;
      });

      if (otherChildren.length === 1) {
        var child = otherChildren[0];

        if (child.keyName) {
          _this.attributes.items = {
            type: 'object',
            items: (0, _defineProperty2.default)({}, child.keyName, child)
          };
        } else {
          _this.attributes.items = child;
        }
      } else {
        _this.attributes.items = {
          type: 'object',
          items: flattenChilden.reduce(function (result, child) {
            if (child.keyName in result) {
              throw new Error("duplicated name in children of ".concat(_this.keyName));
            }

            if (child.__TOOLBAR__) {
              return result;
            }

            result[child.keyName] = child;
            return result;
          }, {})
        };
      }
    }

    return _this;
  }

  (0, _createClass2.default)(ArrayModel, [{
    key: "getDefaultUI",
    value: function getDefaultUI() {
      return 'table';
    }
  }]);
  return ArrayModel;
}(_basic.default);

exports.default = ArrayModel;