"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _basic = _interopRequireDefault(require("./basic"));

var _saferEval = _interopRequireDefault(require("safer-eval"));

var _lodash = require("lodash");

var ObjectModel =
/*#__PURE__*/
function (_BasicModel) {
  (0, _inherits2.default)(ObjectModel, _BasicModel);

  // https://github.com/babel/babel/issues/8417

  /*:: attributes: Object; */
  function ObjectModel(attrs, children) {
    var _this;

    (0, _classCallCheck2.default)(this, ObjectModel);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ObjectModel).call(this, 'object', attrs));
    var builder = _this.attributes.builder;

    if (typeof builder === 'string') {
      builder = (0, _saferEval.default)(builder);
    }

    if (typeof builder === 'function') {
      // $FlowFixMe
      _this.toJson = function () {
        return builder({
          attributes: (0, _objectSpread2.default)({}, attrs, {
            builder: undefined
          }),
          children: children
        });
      };

      return (0, _possibleConstructorReturn2.default)(_this, (0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    }

    if (children && children.length) {
      var flattenChildren = (0, _lodash.flatten)(children);
      _this.attributes.items = flattenChildren.reduce(function (result, child) {
        if (child.keyName in result) {
          throw new Error("duplicated keyName in children of ".concat(_this.attributes.keyName));
        }

        result[child.keyName] = child;
        return result;
      }, {});
    }

    return _this;
  }

  (0, _createClass2.default)(ObjectModel, [{
    key: "getDefaultUI",
    value: function getDefaultUI() {
      return 'fieldset';
    }
  }]);
  return ObjectModel;
}(_basic.default);

exports.default = ObjectModel;