"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var PageModel =
/*#__PURE__*/
function () {
  // babel bug

  /*::
  items: CannerSchema | {[string]: CannerSchema};
  keyName: string;
  title: string;
  */
  function PageModel(_ref, children) {
    var _this = this;

    var keyName = _ref.keyName,
        title = _ref.title;
    (0, _classCallCheck2.default)(this, PageModel);

    if (!keyName) {
      throw new Error('The keyName of <page /> is required');
    }

    this.keyName = keyName;

    if (children && children.length) {
      this.items = children.reduce(function (result, child) {
        if (child.keyName in result) {
          throw new Error("duplicated name in children of ".concat(_this.keyName));
        }

        result[child.keyName] = child;
        return result;
      }, {});
    }

    this.title = title;
  }

  (0, _createClass2.default)(PageModel, [{
    key: "toJson",
    value: function toJson() {
      return {
        keyName: this.keyName,
        type: 'page',
        items: this.items,
        title: this.title
      };
    }
  }]);
  return PageModel;
}();

exports.default = PageModel;