"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _utils = require("../utils");

var BasicModel =
/*#__PURE__*/
function () {
  function BasicModel(tagName, attrs) {
    var _this = this;

    (0, _classCallCheck2.default)(this, BasicModel);
    (0, _defineProperty2.default)(this, "attributes", void 0);
    (0, _defineProperty2.default)(this, "attributes", {});
    (0, _defineProperty2.default)(this, "toJson", function () {
      return (0, _objectSpread2.default)({}, _this.attributes);
    });
    var ui = attrs.ui || this.getDefaultUI();
    var type = attrs.type || tagName;
    this.attributes = (0, _objectSpread2.default)({}, attrs, {
      ui: ui,
      title: attrs.title || '',
      description: attrs.description || '',
      uiParams: attrs.uiParams || {},
      type: type,
      packageName: attrs.packageName || _utils.componentMap.get(type, ui)
    });
  }

  (0, _createClass2.default)(BasicModel, [{
    key: "getDefaultUI",
    value: function getDefaultUI() {
      return 'default';
    }
  }, {
    key: "withToolBar",
    value: function withToolBar(children) {
      var toolbar = children.find(function (child) {
        return child.__TOOLBAR__;
      });

      if (toolbar) {
        this.attributes = (0, _objectSpread2.default)({}, this.attributes, {
          toolbar: toolbar
        });
      }
    }
  }]);
  return BasicModel;
}();

exports.default = BasicModel;