"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _basic = _interopRequireDefault(require("./basic"));

var _layout = require("../layout");

var ComponentModel =
/*#__PURE__*/
function (_BasicModel) {
  (0, _inherits2.default)(ComponentModel, _BasicModel);

  function ComponentModel(_ref, children) {
    var _this;

    var _ref$keyName = _ref.keyName,
        keyName = _ref$keyName === void 0 ? (0, _layout.getRandomKey)() : _ref$keyName,
        attrs = (0, _objectWithoutProperties2.default)(_ref, ["keyName"]);
    (0, _classCallCheck2.default)(this, ComponentModel);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ComponentModel).call(this, 'component', (0, _objectSpread2.default)({
      keyName: keyName
    }, attrs)));

    _this.withToolBar(children);

    return _this;
  }

  return ComponentModel;
}(_basic.default);

exports.default = ComponentModel;