"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _basic = _interopRequireDefault(require("./basic"));

var RelationModel =
/*#__PURE__*/
function (_BasicModel) {
  (0, _inherits2.default)(RelationModel, _BasicModel);

  // https://github.com/babel/babel/issues/8417

  /*::
  attributes: Object;
  */
  function RelationModel(attrs, children) {
    var _this;

    (0, _classCallCheck2.default)(this, RelationModel);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(RelationModel).call(this, 'relation', attrs));

    if (children && children.length) {
      var toolbar = children.find(function (item) {
        return item.__TOOLBAR__;
      });

      if (toolbar) {
        _this.attributes.toolbar = toolbar;
      }
    } else {
      _this.attributes.toolbar = {
        pagination: {}
      };
    }

    return _this;
  }

  (0, _createClass2.default)(RelationModel, [{
    key: "getDefaultUI",
    value: function getDefaultUI() {
      if ((this.attributes.relation || {}).type === 'toMany') {
        return 'multipleSelect';
      }

      return 'singleSelect';
    }
  }]);
  return RelationModel;
}(_basic.default);

exports.default = RelationModel;