"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _visitors = _interopRequireDefault(require("./visitors"));

var VisitorManager = function VisitorManager() {
  var _this = this;

  (0, _classCallCheck2.default)(this, VisitorManager);
  (0, _defineProperty2.default)(this, "defaultVisitors", (0, _toConsumableArray2.default)(_visitors.default));
  (0, _defineProperty2.default)(this, "visitors", []);
  (0, _defineProperty2.default)(this, "resetVisitors", function () {
    _this.visitors.length = 0;
  });
  (0, _defineProperty2.default)(this, "addVisitor", function (visitor) {
    _this.visitors.push(visitor);
  });
  (0, _defineProperty2.default)(this, "setDefaultVisitors", function (visitors) {
    _this.defaultVisitors = (0, _toConsumableArray2.default)(visitors);
  });
  (0, _defineProperty2.default)(this, "getAllVisitors", function () {
    return [].concat((0, _toConsumableArray2.default)(_this.visitors), (0, _toConsumableArray2.default)(_this.defaultVisitors));
  });
};

var _default = new VisitorManager();

exports.default = _default;